

/**
 * @author Z. Pan
 * @version 1.0
 */

import edu.lehigh.swat.hawk.storage.simpledb.DatabaseStorage;
import edu.lehigh.swat.hawk.storage.simpledb.Query;
import edu.lehigh.swat.hawk.storage.simpledb.Atom;
import java.io.*;
import edu.lehigh.swat.hawk.core.*;
import edu.lehigh.swat.hawk.storage.*;

public class QueryDB {

  static DatabaseStorage storage;

  public QueryDB() {
  }

  public static void main(String[] args) {
    if(args.length!=2){
      System.out.println("usage: java QueryDB DB_File_Name query_File_Name");
      System.exit(0);
    }

    QueryDB test = new QueryDB();

    storage = new DatabaseStorage(args[0]);
    storage.open();

 //   Atom atom = new Atom("@everyInstance","Car","?x");
    Query q = test.parseQuery(args[1]);

    ResultSet rs = storage.issueQuery(q);
    String s = rs.toString();
    int n = rs.getResultsNumber();
    System.out.println("results:\n"+s);
    System.out.println("\n------------------\nTotal number of results: "+n);
    storage.close();
  }





  /**
   * Parse the query from file.
   */
  public Query parseQuery(String fn){
    QueryConfigParser qcp = new QueryConfigParser(fn);
    qcp.parse();
    return qcp.query_;
  }

  /////////////////////////////////////////////////////
  ///code below copied from ubt.test.java ////////////
  ////////////////////////////////////////////////////
  abstract private class ConfigParser {
    LineNumberReader reader_;
    protected static final char C_SEC_BEGIN = '[';
    protected static final char C_SEC_END = ']';
    private String fileName_;

    public ConfigParser(String fileName) {
      fileName_ = fileName;
    }

    public void parse() {
      String line;

      handleBeginOfFile();
      while ((line = readLine()) != null) {
        handleLine(line);
      }
      handleEndOfFile();
    }

    abstract protected void handleLine(String line);
    protected void handleBeginOfFile() {/*do nothing*/}
    protected void handleEndOfFile() {/*do nothing*/}

    private String readLine() {
      String line = null;

      try {
        while ((line = reader_.readLine()) != null) {
          line.trim();
          if (line.length() > 0) break;
        }
      }
      catch (IOException e) {
        e.printStackTrace();
        System.exit(1);
      }

      return line;
    }

    protected void error(String error) {
      System.out.println(fileName_ + ": Line " + reader_.getLineNumber() + ": " + error);
      System.exit(1);
    }

    protected boolean isStartOfSection(String line) {
      if (line.charAt(0) != C_SEC_BEGIN) {
        return false;
      }
      else {
        if (line.charAt(line.length() - 1) != C_SEC_END) {
          error("Syntax Error!");
          return false;
        }
        return true;
      }
    }
  }


  private class QueryConfigParser extends ConfigParser {

    protected static final char C_ATOM_BEGIN = '(';
    protected static final char C_ATOM_END = ')';
    protected static final char C_ARG_DELIM = ' ';
    Query query_; //current section

    public QueryConfigParser(String CONFIG_FILE_QUERY) {
      super(CONFIG_FILE_QUERY);
      try {
        reader_ = new LineNumberReader(new FileReader(CONFIG_FILE_QUERY));
        query_ = null;
      }
      catch (FileNotFoundException e) {
        e.printStackTrace();
        System.exit(1);
      }
    }

    protected void handleLine(String line) {
      if (line.startsWith("#")) return;

      String predicate;
      String[] args;
      int i, j, n;

      if (isStartOfSection(line)) {
        endPrevSection();
        //new section
        query_ = new Query();
        String did = line.substring(1, line.length() - 1);
       // query_.id_ = line.substring(1, line.length() - 1);
        if (did.length() <= 0) {
          error("Empty Id!");
        }
        query_.setPerspective(new DocId(did));
      }
      else {
        if (line.charAt(0) != C_ATOM_BEGIN || line.charAt(line.length() - 1) != C_ATOM_END) {
          //for now, on syntax error, just remember the line
          //error("Syntax Error");
        //  query_.query_.setSource(query_.query_.getSource() + "\n" + line);
        //  return;
        }
        line = line.substring(1, line.length() - 1);
        i = 0;
        for (n = 0; (i = line.indexOf(C_ARG_DELIM, i + 1)) >= 0; n++);
        if (n < 0) {
          predicate = line;
          args = null;
        }
        else {
          predicate = line.substring(0, i = line.indexOf(C_ARG_DELIM));
          line = line.substring(++i);
          args = new String[n];
          for (j = 0; j < n - 1; j++) {
            args[j] = line.substring(0, i = line.indexOf(C_ARG_DELIM));
            line = line.substring(++i);
          }
          args[j] = line;
        }
        Atom atom = new Atom(predicate,args);
        query_.addConjunct(atom);
      }
    }

    protected void handleEndOfFile() {
      if (query_ != null) {
        endPrevSection();
      }
    }

    private void endPrevSection() {
      if (query_ != null) {

        //queryList_.add(query_);
      }
    }
  }








}
