/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/

package edu.lehigh.swat.hawk.owl;


import edu.lehigh.swat.hawk.core.*;

import org.w3c.dom.*;
import org.apache.xerces.dom.*;
import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;

import java.io.*;
import java.util.*;


/** Experimental Renderer for the new DIG language. This is primarily
 * intended as a testbed for the new language definition that the <a
 * href="http://dl.kr.org/dig">DIG</a> group are working on. Very
 * similar to the original SHIQ renderer in its makeup. Warning: This
 * may not work properly.

/**
 * OWL to DIG Writer. Output owl ontology to DIG 1.1 format.
 * @author Z. Pan
 * @version 1.0
 */

public class OwlDigWriter {

      /** Create a new instance of the renderer */
      public OwlDigWriter() {
      }

      /** Set options for the renderer.  */
      public void setOption(String str, int i) {
      }

      /* A pair of tables, one mapping names to concepts, the other
         mapping concepts to names. The tables represent the mappings
         that the renderer has used. These are required because names
         get mangled when sending stuff to FaCT. */

      /** Render an ontology in SHIQ using the given writer */
      public void writeOntology(Ontology o, Writer w) throws Exception {
          //buildNameTables(o);
          //  PrintStream out = new PrintStream(os);
          PrintWriter out = new PrintWriter(w);
          DocumentImpl doc = new DocumentImpl();
          // 	DocumentType dc = doc.createDocumentType("tells", null, "tell.dtd");
          // 	doc.appendChild(dc);
          Element root = doc.createElement("tells");

          root.setAttribute("xmlns","http://dl.kr.org/dig/2003/02/lang");
      	  root.setAttribute("xmlns:xsi","http://www.w3.org/2001/XMLSchema-instance");
 	  root.setAttribute("xsi:schemaLocation", "http://dl-web.man.ac.uk/dig/2003/02/dig.xsd");
          //	root.setAttribute("xmlns:xsd", "http://www.w3.org/2001/XMLSchema");
          doc.appendChild(root);

         // Element clear = doc.createElement("clearKB"); //comment out by z.pan
         // root.appendChild(clear);

          Iterator it = o.getClassIterator();
          while (it.hasNext()) {
              edu.lehigh.swat.hawk.core.OntClass cl = (edu.lehigh.swat.hawk.core.OntClass) it.next();
              String className = cl.getID().getId();
              Element defcon = doc.createElement("defconcept");
              defcon.setAttribute("name", className);
              root.appendChild(defcon);
          }

          it = o.getPropertyIterator();
          while (it.hasNext()) {
              OntProperty sl = (OntProperty) it.next();
              String propertyName = sl.getID().getId();

              if (sl.isDatatype()==null||!sl.isDatatype().booleanValue()) {
                Element defRole = doc.createElement("defrole");
                defRole.setAttribute("name", propertyName);
                root.appendChild(defRole);
              }
              else {
                Element defAtt = doc.createElement("defattribute");
                defAtt.setAttribute("name", propertyName);
                root.appendChild(defAtt);
              }
          }

          it = o.getClassIterator();
          while (it.hasNext()) {
              edu.lehigh.swat.hawk.core.OntClass cl = (edu.lehigh.swat.hawk.core.OntClass) it.next();
              writeClass(o, cl, doc, root);
          }

          it = o.getPropertyIterator();
          while (it.hasNext()) {
              OntProperty sl = (OntProperty) it.next();
              writeProperty(o, sl, doc, root);
          }

         // writeRestrictions(o,doc,root);
         it = o.getIndividualIterator();
         while(it.hasNext()){
           Individual ind = (Individual)it.next();
           writeIndividual(o, ind, doc, root);
         }
/*
          it = o.getIndividuals().begin();
          String[] indNames = new String[o.getIndividuals().size()];
          int count = 0;
          while (!it.atEnd()) {
              Individual ind = (Individual) it.get();
              renderIndividual(ind, doc, root);
              indNames[count] = nameFor(ind);
              count++;
              it.advance();
          }

          it = o.getAxioms().begin();
          while (!it.atEnd()) {
              Axiom ax = (Axiom) it.get();
              renderAxiom(ax, doc, root);
              it.advance();
          }
*/

          try {
            OutputFormat format = new OutputFormat(doc);
            format.setLineWidth(65);
            format.setIndenting(true);
            format.setIndent(2);

            XMLSerializer serializer = new XMLSerializer(out, format);
            serializer.serialize(doc);
              /* Set up the cdata elements */
              // 	    String[] cdata = new String[cdataElements.size()+1];
              // 	    cdata[0] = "rdfs:comment";
              // 	    int i = 1;
              // 	    for (Enumeration els = cdataElements.elements();
              // 		 els.hasMoreElements();) {
              // 		String cd = (String) els.nextElement();
              // 		cdata[i] = cd;
              // 		i++;
              // 	    }
              //dw.serialize(doc, out, true, new String[0]);
          } catch (IOException e) {
              throw new Exception(e);
          }

          //DOMWriter dw = new DOMWriter(new PrintWriter(out));
          //dw.print(doc.getDocumentElement());
      }

      private void writeClass(Ontology o, OntClass cl, org.w3c.dom.Document doc, Element root) {
          String className = cl.getID().getId();
          Element cc = doc.createElement("catom");
          cc.setAttribute("name",className);

          ObjectId[] superClasses = cl.getDirectSuperClasses();
          if (superClasses.length>0) {
              int slen = superClasses.length;
              for(int i=0;i<slen;i++) {
                  Element axiom = doc.createElement("impliesc");
                  axiom.appendChild(cc.cloneNode(false));
                  ObjectId superClass = superClasses[i];
                  if(o.getRestriction(superClass)==null){
                    Element sc = doc.createElement("catom");
                    sc.setAttribute("name",superClass.getId());
                    axiom.appendChild(sc);
                  }
                  else{
                    PropertyRestriction pr = o.getRestriction(superClass);
                    Element pre = writeRestriction(o,pr,doc);
                    if(pre==null)
                      continue;
                    axiom.appendChild(pre);
                  }
                  root.appendChild(axiom);
              }
          }

          ObjectId[] equalClasses = cl.getEquivalentClasses();
          if (equalClasses.length>0) {
              int slen = equalClasses.length;
              for(int i=0;i<slen;i++) {
                  Element axiom = doc.createElement("equalc");
                  axiom.appendChild(cc.cloneNode(false));
                  ObjectId equalClass = equalClasses[i];
                  if(o.getRestriction(equalClass)==null){
                    Element sc = doc.createElement("catom");
                    sc.setAttribute("name",equalClass.getId());
                    axiom.appendChild(sc);
                  }
                  else{
                    PropertyRestriction pr = o.getRestriction(equalClass);
                    Element pre = writeRestriction(o,pr,doc);
                    if(pre==null)
                      continue;
                    axiom.appendChild(pre);
                  }
                  root.appendChild(axiom);
              }
          }

          ObjectId[] unionClasses = cl.getUnionOfs();
          if (unionClasses.length>0) {
              Element axiom = doc.createElement("equalc");
              axiom.appendChild(cc.cloneNode(false));
              Element disj = doc.createElement("or");
              int slen = unionClasses.length;
              for(int i=0;i<slen;i++) {
                  ObjectId unionClass = unionClasses[i];
                  if(o.getRestriction(unionClass)==null){
                    Element sc = doc.createElement("catom");
                    sc.setAttribute("name",unionClass.getId());
                    disj.appendChild(sc);
                  }
                  else{
                    PropertyRestriction pr = o.getRestriction(unionClass);
                    Element pre = writeRestriction(o,pr,doc);
                    if(pre==null)
                      continue;
                    disj.appendChild(pre);
                  }
              }
              axiom.appendChild(disj);
              root.appendChild(axiom);
          }

          ObjectId[] interClasses = cl.getIntersectionOfs();
          if (interClasses.length>0) {
              Element axiom = doc.createElement("equalc");
              axiom.appendChild(cc.cloneNode(false));
              Element conj = doc.createElement("and");
              int slen = interClasses.length;
              for(int i=0;i<slen;i++) {
                  ObjectId interClass = interClasses[i];
                  if(o.getRestriction(interClass)==null){
                    Element sc = doc.createElement("catom");
                    sc.setAttribute("name",interClass.getId());
                    conj.appendChild(sc);
                  }
                  else{
                    PropertyRestriction pr = o.getRestriction(interClass);
                    Element pre = writeRestriction(o,pr,doc);
                    if(pre==null)
                      continue;
                    conj.appendChild(pre);
                  }
              }
              axiom.appendChild(conj);
              root.appendChild(axiom);
          }

          ObjectId[] complmentClasses = cl.getComplementOfs();
          if (complmentClasses.length>0) {
              int slen = complmentClasses.length;
              for(int i=0;i<slen;i++) {
                  Element axiom = doc.createElement("equalc");
                  axiom.appendChild(cc.cloneNode(false));
                  Element not = doc.createElement("not");
                  ObjectId complmentClass = complmentClasses[i];
                  if(o.getRestriction(complmentClass)==null){
                    Element sc = doc.createElement("catom");
                    sc.setAttribute("name",complmentClass.getId());
                    not.appendChild(sc);
                  }
                  else{
                    PropertyRestriction pr = o.getRestriction(complmentClass);
                    Element pre = writeRestriction(o,pr,doc);
                    if(pre==null)
                      continue;
                    not.appendChild(pre);
                  }
                  axiom.appendChild(not);
                  root.appendChild(axiom);
              }
          }

          ObjectId[] disjointClasses = cl.getDisjointWith();
          if (disjointClasses.length>0) {
              int slen = equalClasses.length;
              for(int i=0;i<slen;i++) {
                  Element axiom = doc.createElement("disjoint");
                  axiom.appendChild(cc.cloneNode(false));
                  ObjectId disjointClass = disjointClasses[i];
                  if(o.getRestriction(disjointClass)==null){
                    Element sc = doc.createElement("catom");
                    sc.setAttribute("name",disjointClass.getId());
                    axiom.appendChild(sc);
                  }
                  else{
                    PropertyRestriction pr = o.getRestriction(disjointClass);
                    Element pre = writeRestriction(o,pr,doc);
                    if(pre==null)
                      continue;
                    axiom.appendChild(pre);
                  }
                  root.appendChild(axiom);
              }
          }
      }

      private void writeProperty(Ontology o, OntProperty sl, org.w3c.dom.Document doc, Element root) {

        String propertyName = sl.getID().getId();
        Element pp = null;

        if (sl.isDatatype()==null||!sl.isDatatype().booleanValue()) {
          pp = doc.createElement("ratom");
        }
        else{
            pp = doc.createElement("attribute");
        }
        pp.setAttribute("name",propertyName);

          ObjectId[] superProperties = sl.getDirectSuperProperties();
          int len = superProperties.length;
          for(int i=0;i<len;i++){
              ObjectId superProperty = superProperties[i];

              Element axiom = doc.createElement("impliesr");
              axiom.appendChild(pp.cloneNode(false));

              Element sp;
//              if(o.getProperty(superProperty)==null) //test
//                System.out.println(o.getID().getId()+"  :  "+superProperty.getId());//test
              Boolean isDatatype = null;
              if(o.getProperty(superProperty)!=null)
                isDatatype = o.getProperty(superProperty).isDatatype();
              if(isDatatype==null||!isDatatype.booleanValue())
                sp = doc.createElement("ratom");
              else
                sp = doc.createElement("attribute");
              sp.setAttribute("name",superProperty.getId());

              axiom.appendChild(sp);
              root.appendChild(axiom);
          }

          ObjectId[] inverses = sl.getInverseOf();
          len = inverses.length;
          for(int i=0;i<len;i++){
              ObjectId inv = inverses[i];

              Element axiom = doc.createElement("equalr");
              // Left hand side of axiom is the current property
              axiom.appendChild(pp.cloneNode(false));

              Element invr = doc.createElement("inverse");
              Element ip = doc.createElement("ratom");
              ip.setAttribute("name",inv.getId());
              invr.appendChild(ip);

              // Right hand side of the axiom is the inverse of
              // the given name
              axiom.appendChild(invr);

              root.appendChild(axiom);
          }

          ObjectId domain = sl.getDomain();
          if(domain!=null){
            Element dom = doc.createElement("catom");
            dom.setAttribute("name",domain.getId());
            Element daxiom = doc.createElement("domain");
            daxiom.appendChild(pp.cloneNode(false));
            daxiom.appendChild(dom);
            root.appendChild(daxiom);
          }
          //There are different kinds of integer in XSD??
          ObjectId range = sl.getRange();
          if(range!=null){
            if (range.getId().equals(DatatypeValue.INTEGER)) {
              Element raxiom = doc.createElement("rangeint");
              raxiom.appendChild(pp.cloneNode(false));
              root.appendChild(raxiom);
            }
            else if (range.getId().equals(DatatypeValue.STRING)) {
              Element raxiom = doc.createElement("rangestring");
              raxiom.appendChild(pp.cloneNode(false));
              root.appendChild(raxiom);
            }
            else if (o.getOntClass(range) != null) {
              Element raxiom = doc.createElement("range");
              raxiom.appendChild(pp.cloneNode(false));

              Element rc = doc.createElement("catom");
              rc.setAttribute("name", range.getId());
              raxiom.appendChild(rc);

              root.appendChild(raxiom);
            }
          }

          if (sl.isTransitive()) {
              // It's a transitivity axiom. Add the axiom
              // applied to the current property.
              Element axiom = doc.createElement("transitive");
              axiom.appendChild(pp.cloneNode(false));
              root.appendChild(axiom);
          }

          if (sl.isSymmetric()) {
              // Its a symmetry axiom. We need to say that
              // the current property is equal to its inverse.
              Element axiom = doc.createElement("equalr");
              // Left hand side of axiom is the current property
              axiom.appendChild(pp.cloneNode(false));

              // Right hand side of the axiom is the inverse of
              // the current property

              Element invr = doc.createElement("inverse");
              axiom.appendChild(invr);

              invr.appendChild(pp.cloneNode(false));
              root.appendChild(axiom);
          }

          if (sl.isFunctional()) {
              // It's a functional axiom. Add the axiom
              // applied to the current property.
              Element axiom = doc.createElement("functional");
              axiom.appendChild(pp.cloneNode(false));
              root.appendChild(axiom);
          }
      }

      /**
       * Create an element for a Restriction.
       */
      private Element writeRestriction(Ontology ont, PropertyRestriction r,
                                       org.w3c.dom.Document doc){

        Element top = doc.createElement("top");
        //onProperty
        ObjectId opid = r.getOnProperty();
        Element onProperty = doc.createElement("ratom");
        onProperty.setAttribute("name",opid.getId());

        //allValuesFrom
        ObjectId avf = r.getAllValuesFrom();
        if(avf!=null){
          Element eavf = doc.createElement("catom");
          eavf.setAttribute("name",avf.getId());
          Element all = doc.createElement("all");
          all.appendChild(onProperty.cloneNode(false));
          all.appendChild(eavf);
          return all;
        }

        //someValuesFrom
        ObjectId svf = r.getSomeValuesFrom();
        if(svf!=null){
          Element esvf = doc.createElement("catom");
          esvf.setAttribute("name",svf.getId());
          Element some = doc.createElement("some");
          some.appendChild(onProperty.cloneNode(false));
          some.appendChild(esvf);
          return some;
        }

        //hasValue
        ObjectId hv = r.getHasValue();
        if(hv!=null){
          if(hv instanceof DatatypeValue){
            DatatypeValue dhv = (DatatypeValue)hv;
            if(dhv.getType().equalsIgnoreCase(DatatypeValue.INTEGER)){
              Element in = doc.createElement("intequals");
              in.setAttribute("val",dhv.getValue());
              in.appendChild(onProperty.cloneNode(false));
              return in;
            }
            if(dhv.getType().equalsIgnoreCase(DatatypeValue.STRING)){
              Element st = doc.createElement("stringequals");
              st.setAttribute("val",dhv.getValue());
              st.appendChild(onProperty.cloneNode(false));
              return st;
            }
          }
          Element ind = doc.createElement("individual");
          ind.setAttribute("name", hv.getId());
          Element iset = doc.createElement("iset");
          iset.appendChild(ind);
          Element has = doc.createElement("some");
          has.appendChild(onProperty.cloneNode(false));
          has.appendChild(ind);
          return has;
        }

        //cardinality
        int maxcard = r.getMaxCardinality();
        int mincard = r.getMinCardinality();

        if(mincard==maxcard){
          Element most = doc.createElement("atmost");
          most.appendChild(onProperty);
          most.appendChild(top);
          most.setAttribute("num",String.valueOf(maxcard));
          Element least = doc.createElement("atleast");
          least.setAttribute("num",String.valueOf(mincard));
          least.appendChild(onProperty.cloneNode(false));
          least.appendChild(top.cloneNode(false));
          Element and = doc.createElement("and");
          and.appendChild(most);
          and.appendChild(least);
          return and;
        }
        //maxCardinality

        if(maxcard!=PropertyRestriction.INFINIT&&maxcard!=mincard){
          Element most = doc.createElement("atmost");
          most.appendChild(onProperty.cloneNode(false));
          most.appendChild(top.cloneNode(false));
          most.setAttribute("num",String.valueOf(maxcard));
          return most;
        }
        //minCardinality

        if(mincard!=0&&mincard!=maxcard){
          Element least = doc.createElement("atleast");
          least.appendChild(onProperty.cloneNode(false));
          least.appendChild(top.cloneNode(false));
          least.setAttribute("num",String.valueOf(mincard));
          return least;
        }

        return null;
      }


      /**
       * write an individual.
       */
      private void writeIndividual(Ontology onto, Individual ind,
                                   org.w3c.dom.Document doc, Element root) {
        Element eind = doc.createElement("individual");
        String iname = ind.getID().getId();
        eind.setAttribute("name",iname);

        ObjectId[] sc = ind.getSourceClasses();
        int sclen = sc.length;
        for(int i=0;i<sclen;i++){
          Element eio = doc.createElement("instanceof");
          eio.appendChild(eind.cloneNode(false));
          ObjectId scid = sc[i];
          Element esc = doc.createElement("catom");
          esc.setAttribute("name",scid.getId());
          eio.appendChild(esc);
          root.appendChild(eio);
        }

        ObjectId[] pps = ind.getProperties();
        int pplen = pps.length;
        for(int i=0;i<pplen;i++){
          ObjectId pp = pps[i];
          ObjectId[] pvs = ind.getValuesForProperty(pp);
          int pvlen = pvs.length;
          for(int j=0;j<pvlen;j++){
            ObjectId pv = pvs[j];
            if(pv instanceof DatatypeValue){
              Element epp = doc.createElement("attribute");
              epp.setAttribute("name",pp.getId());
              Element epv = doc.createElement("value");
              DatatypeValue dv = (DatatypeValue)pv;
              Element edv = null;
              if(dv.getType().equals(DatatypeValue.STRING))
                edv = doc.createElement("sval");
              else if(dv.getType().equals(DatatypeValue.INTEGER))
                edv = doc.createElement("ival");
              Text tv = doc.createTextNode(dv.getValue());
              if(edv==null)
                continue;
              edv.appendChild(tv);
              epv.appendChild(eind.cloneNode(false));
              epv.appendChild(epp);
              epv.appendChild(edv);
              root.appendChild(epv);
            }
            else{
              Element epp = doc.createElement("ratom");
              epp.setAttribute("name",pp.getId());
              Element epv = doc.createElement("related");
              Element evv = doc.createElement("individual");
              evv.setAttribute("name",pv.getId());
              epv.appendChild(eind.cloneNode(false));
              epv.appendChild(epp);
              epv.appendChild(evv);
              root.appendChild(epv);
            }
          }
        }
      }



/*
      private void renderIndividual(Individual i, Document doc, Element root) {
          Element defcon = doc.createElement("defindividual");
          defcon.setAttribute("name", nameFor(i));
          root.appendChild(defcon);


          // Add an implication for each superclass
          ListWrapper superClasses = i.getSuperClasses();
          if (superClasses.size()>0) {
              Element conj = doc.createElement("and");
              DListIterator superIt = superClasses.begin();
              while (!superIt.atEnd()) {
                  ClassExpression superClass = (ClassExpression) superIt.get();
                  ExpressionRenderer ets = new ExpressionRenderer(doc, this);
                  superClass.accept(ets);
                  conj.appendChild(ets.element());
                  superIt.advance();
              }
              Element axiom = doc.createElement("instanceof");
              Element lhs = doc.createElement("individual");
              axiom.appendChild(lhs);
              lhs.setAttribute("name", nameFor(i));

              axiom.appendChild(conj);
              root.appendChild(axiom);
          }

             // Add an implication for each relationship

          DListIterator propertyIt = i.relatedProperties().begin();
          while (!propertyIt.atEnd()) {
              Property property = (Property) propertyIt.get();
              DListIterator fillIt = i.valuesForProperty(property).begin();
              while (!fillIt.atEnd()) {
                   try {
                       Individual fill = (Individual) fillIt.get();
                      // Knock up an implication

                       Element axiom = doc.createElement("related");

                       Element i1 = doc.createElement("individual");
                      i1.setAttribute("name", nameFor(i));
                       axiom.appendChild(i1);

                       axiom.appendChild(primRole(nameFor(property), doc));

                       Element i2 = doc.createElement("individual");
                      i2.setAttribute("name", nameFor(fill));

                      axiom.appendChild(i2);

                      // Add the axiom
                       root.appendChild(axiom);
                   } catch (ClassCastException ex) {
                       // It's not an individual - try for a concrete
                       try {
                           DatatypeValue fill = (DatatypeValue) fillIt.get();


                          Element axiom = doc.createElement("value");

                          Element i1 = doc.createElement("individual");
                          i1.setAttribute("name", nameFor(i));
                          axiom.appendChild(i1);

                          axiom.appendChild(primAtt(nameFor(property), doc));

                          if (fill.getType().getType() == Datatype.STRING) {
                              Element f = doc.createElement("sval");
                              Text ft = doc.createTextNode(fill.getValue());
                              f.appendChild(ft);
                              axiom.appendChild(f);
                          } else if (fill.getType().getType() == Datatype.INTEGER) {
                              Element f = doc.createElement("ival");
                              Text ft = doc.createTextNode(fill.getValue());
                              f.appendChild(ft);
                              axiom.appendChild(f);
                          }
                           root.appendChild(axiom);
                       } catch (ClassCastException ex2) {
                           // Ignore. It's something we don't know about
                       }
                   }
                   fillIt.advance();
              }
              propertyIt.advance();
          }
      }

      private void renderAxiom(Axiom ax, Document doc, Element root) {
          AxiomRenderer ats = new AxiomRenderer(doc, root, this);
          ax.accept(ats);
      }

      private Element primitive(String name, Document doc) {
          Element prim = doc.createElement("catom");
          prim.setAttribute("name", name);
          return prim;
      }

      // Helper function
      private Element primRole(String name, Document doc) {
          Element primR = doc.createElement("ratom");
          primR.setAttribute("name", name);
          return primR;
      }

      private Element primAtt(String name, Document doc) {
          Element primR = doc.createElement("attribute");
          primR.setAttribute("name", name);
          return primR;
      }

*/
}




