package edu.lehigh.swat.hawk.owl;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.*;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import java.util.HashMap;
import java.io.*;


/**
 * An xml parser to parse namespces etc.
 * @author Z. Pan
 * @version 1.0
 */
class PreParser {

  public PreParser(String uri) {
    try {
      DocumentBuilderFactory factory =
      DocumentBuilderFactory.newInstance();
      DocumentBuilder builder = factory.newDocumentBuilder();
      document = builder.parse(uri);
    }catch(Exception e){
      System.out.println(e.getMessage());
      e.printStackTrace();
    }
    xmlBase = "";
  }

  public PreParser(InputStream uri) {
   try {
    DocumentBuilderFactory factory =
    DocumentBuilderFactory.newInstance();
    DocumentBuilder builder = factory.newDocumentBuilder();
    document = builder.parse(uri);
   }catch(Exception e){
     System.out.println(e.getMessage());
     e.printStackTrace();
   }
   xmlBase = "";
  }

  public PreParser(Reader uri) {
   try {
     DocumentBuilderFactory factory =
    DocumentBuilderFactory.newInstance();
    DocumentBuilder builder = factory.newDocumentBuilder();
    document = builder.parse(new InputSource(uri));
   }catch(Exception e){
     System.out.println(e.getMessage());
     e.printStackTrace();
   }
  }

  /**
   * Get the namespaces and their prefixes.
   * @return
   */
  public HashMap getNamespaces(){
    HashMap map = new HashMap();
    NamedNodeMap nm = document.getDocumentElement().getAttributes();
    int len = nm.getLength();
    for(int i=0;i<len;i++){
      Node node = nm.item(i);
      if(node.getNodeName().startsWith("xmlns:")){
        String name = node.getNodeName();
        String prefix = name.substring(6);
        String url = node.getNodeValue();
        map.put(url,prefix);
      }
      if(node.getNodeName().equalsIgnoreCase("xml:base"))
        xmlBase = node.getNodeValue();
        if(xmlBase.endsWith("#")){
            xmlBase = xmlBase.substring(0,xmlBase.length()-1);
        }
    }
    return map;
  }

  /**
   * Get the XML Base. Note this method has to be called after getNamespaces().
   * @return
   */
  public String getXMLBase(){
    return xmlBase;
  }

  private Document document;
  private String xmlBase;
}
