/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/


package edu.lehigh.swat.hawk.storage;

import java.util.Vector;
import java.util.Iterator;

/**
 * Encapsulating the set of results to a query.
 * @author Z. Pan
 * @version 1.0
 */

public class ResultSet {

  /**
   * Constructor
   */
  public ResultSet() {
    results = new Vector();
  }

  /**
   * add a result
   */
  public void addResult(Result r){
    results.add(r);
  }

  /**
   * delete a result
   */
  public void deleteResult(Result r){
    results.remove(r);
  }

  /**
   * Get the next result.
   */
  public Result getNextResult(){
    return (Result)it.next();
  }

  /**
   * Tell if the set has more element.
   */
  public boolean hasMoreResults(){
    if(it == null)
      it = results.iterator();
    return it.hasNext();
  }

  /**
   * Get the number of results.
   */
  public int getResultsNumber(){
    return results.size();
  }

  /**
   * ToString method.
   */
  public String toString(){
    String s = "\n";
    int size = results.size();
    for(int i=0;i<size;i++){
      s = s+results.get(i).toString()+"\n";
    }
    return s;
  }

  private Vector results;
  private Iterator it = null;
}