/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/


package edu.lehigh.swat.hawk.storage;
import edu.lehigh.swat.hawk.core.*;
import java.util.Iterator;
import java.util.Hashtable;

/**
 * <p>Title: StorageModel.java</p>
 * <p>Description: a general representation of storage model. implementations
 * depend on different storage approaches</p>
 * <p> </p>
 * <p> </p>
 * @author Z. Pan
 * @version 1.0
 */

public abstract class StorageModel {


  /**
   * Add a document to this model.
   */
  public abstract void addDocument(Document d);

  /**
   * Get the specified document.
   */
  public abstract Document getDocument(String url);

  /**
   * Update a document.
   */
  public abstract void updateDocument(Document d);

  /**
   * Get all the documents in the model.
   */
  public abstract Iterator getDocumentIterator();

  /**
   * Set whether or not include implictly imported documents.
   */
  public abstract void setImplictImports(boolean imp);


  /**
   * Create an Ontology object.
   */
  public abstract Ontology createOntology();

  /**
   * Create an Document object.
   */
  public abstract Document createDocument();

  /**
   *
   * Get the sequence number for giving Document
   */
  public abstract int getSeqNum(DocId did);

}