/*
*Copyright: Copyright (c) 2003-2004, Lehigh University. All rights reserved.
*License Statement: The GNU General Public License
*/


package edu.lehigh.swat.hawk.storage.simpledb;

//import java.util.Set;
//import java.util.*;
import java.sql.Statement;
import java.sql.SQLException;
//import edu.lehigh.swat.hawk.core.DocId;
import edu.lehigh.swat.hawk.core.ObjectId;
import edu.lehigh.swat.hawk.storage.StorageModel;
/**
 * representing semantic contents in a document and/or its imported documents
 * @author Z. Pan
 * @version 1.0
 * Note: we flush the document right before we create any individuals.
 */

public class Document extends edu.lehigh.swat.hawk.storage.simplememory.Document{// edu.lehigh.swat.hawk.core.Document{

  /**
   * Constructor.
   */
  public Document(){
    super();
  }


  /**
   * Create a Individual object.
   */
  public edu.lehigh.swat.hawk.core.Individual createIndividual(){
    Individual indiv = new Individual();
    indiv.setSource(this);
    indiv.setSQLStatement(stmt);
    return indiv;
  }


  /**
   * Add an individual.
   */
  public void addIndividual(edu.lehigh.swat.hawk.core.Individual indiv){
    super.addIndividual(indiv);


  }


  /**
   * Set the document sequence number.
   */
  public void setDocSeq(int i){
    docSeq = i;
  }

  /**
   * Get the document sequence number.
   */
  public int getDocSeq(){
    return docSeq;
  }

  /**
   * Set the SQL statement.
   */
  public void setSQLStatement(Statement statement){
    stmt = statement;
  }

  /**
   * Set the storageModel.
   */
  public void setModel(StorageModel m){
    model = (DatabaseStorage)m;
  }

  /**
   * Get the storageModel.
   */
  public StorageModel getModel(){
    return model;
  }


  /**
   * Flush the axioms into database.
   */
  public void flush(){
    edu.lehigh.swat.hawk.core.Individual[] indis = this.getAllIndividuals();
    int lens = indis.length;
    for(int i=0;i<lens;i++){
      edu.lehigh.swat.hawk.core.Individual indiv = indis[i];
      ObjectId[] sclasses = indiv.getSourceClasses();
      int len = sclasses.length;
      for(int j=0;j<len;j++){
        ObjectId scid = sclasses[j];
        String tableName = model.getTableName(scid);

        int ontNum = model.decideCommitOnto(this,scid);

        int indivId = model.getUrlIndex(indiv.getID().getId());

        if(tableName!=null){
          String qs = "INSERT INTO " + tableName + " VALUES ("
            + indivId+ ", "+docSeq+", "+ontNum+")";
          try {
            stmt.executeUpdate(qs);
          }
          catch(SQLException e){
            System.out.println("error when store individual");
            System.out.println("SQLState:"+e.getSQLState());
            System.out.println("Message :"+e.getMessage());
            System.out.println("Vendor  :"+e.getErrorCode());
          }
        }
      }
    }
  }

  private int docSeq;
  protected Statement stmt;
  protected DatabaseStorage model;
}
